从零开始编写自己的JavaScript框架（三）
====

#3. DOM操作

作为一个前端框架，操作DOM是一个必不可少的功能。最广为人知的DOM操作框架是jQuery，它的选取器和链式操作，都给人们留下深刻印象。

在我们这个框架里，目标不是像它那样做一个全功能的DOM操作库，而是只做一部分很常用的功能。

##3.1. 链式表达式

在本系列的第三部分中，我们提到过链式表达式，想要有这样的效果，返回结果必须作过特殊处理。这个返回结果上要能够继续被执行方法，而且每个方法的执行结果还是自身这个实例。

注意jQuery的$方法，虽然我不赞同它的实现，但用它来说明思路还是可以的。它为什么要这么写呢，是因为想要把选取到的DOM元素再封装一层。试想一下，如果你不对这些DOM作封装，怎么能让它有on，addClass等方法呢？

所以，我们也来做这么一个封装。

function DOM() {
	this.elements = [];
}

DOM.prototype = {
	attr: function() {
		this.elements.forEach(function(element) {

		});
		return this;
	},

	addClass: function() {

	},

	removeClass: function() {

	}
};

var DOMSelector = {
	byId: function(id) {
		var dom = new DOM();
		dom.elements.push(document.getElementById(id));

		return dom;
	}	
}